/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         __fast_recovery_parser_parse
#define yylex           __fast_recovery_parser_lex
#define yyerror         __fast_recovery_parser_error
#define yydebug         __fast_recovery_parser_debug
#define yynerrs         __fast_recovery_parser_nerrs

#define yylval          __fast_recovery_parser_lval
#define yychar          __fast_recovery_parser_char

/* Copy the first part of user declarations.  */
#line 1 "./osm_fast_recovery_parser_y.y" /* yacc.c:339  */

/*
 * Copyright (c) 2023 NVIDIA CORPORATION & AFFILIATES. All rights reserved.
 *
 * This software is available to you under a choice of one of two
 * licenses.  You may choose to be licensed under the terms of the GNU
 * General Public License (GPL) Version 2, available from the file
 * COPYING in the main directory of this source tree, or the
 * OpenIB.org BSD license below:
 *
 *     Redistribution and use in source and binary forms, with or
 *     without modification, are permitted provided that the following
 *     conditions are met:
 *
 *      - Redistributions of source code must retain the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer.
 *
 *      - Redistributions in binary form must reproduce the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer in the documentation and/or other materials
 *        provided with the distribution.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 */

/*
 * Abstract:
 *    Grammar of OSM Fast Recovery configuration parser.
 *
 * Author:
 *    Or Nechemia, NVIDIA
 */

#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <ctype.h>
#include <math.h>
#include <opensm/osm_file_ids.h>
#define FILE_ID OSM_FILE_FAST_RECOVERY_PARSER_Y_Y
#include <opensm/osm_opensm.h>

#define CHECK_PARAMS_PHYSP 	(uint8_t)1
#define CHECK_PARAMS_ALL 	(uint8_t)0xF

static void parser_tmp_struct_reset();
#define RESET_BUFFER  parser_tmp_struct_reset()

typedef struct fast_recovery_tmp_parser_struct_t_ {
	cl_list_t str_list;
	uint16_t num;
	boolean_t boolean;
} fast_recovery_tmp_parser_struct_t;

static struct osm_opensm *p_osm;
char *__fast_recovery_parser_yylval = NULL;
extern FILE * __fast_recovery_parser_in;
static fast_recovery_tmp_parser_struct_t fast_rec_tmp_parser_struct;
static cl_list_t port_group_list;
static ib_credit_watchdog_config_t credit_watchdog_parsed;
static ib_ber_config_t ber_config_parsed[IB_BER_NUM_TYPES];
uint8_t next_profile_num = 1;
static ib_ber_type_t ber_type = IB_BER_TYPE_MAX;
static ib_fast_recovery_threshold_type_t threshold_type = IB_THR_TYPE_RESERVED;
static boolean_t default_thr[IB_BER_TYPE_MAX];

int fast_recovery_column_num;
int fast_recovery_line_num;

static void parser_tmp_struct_init()
{
	cl_list_construct(&fast_rec_tmp_parser_struct.str_list);
	cl_list_init(&fast_rec_tmp_parser_struct.str_list, 10);
	cl_list_construct(&port_group_list);
	cl_list_init(&port_group_list, 10);
}

static void parser_tmp_struct_reset()
{
	cl_list_remove_all(&fast_rec_tmp_parser_struct.str_list);
	fast_rec_tmp_parser_struct.num = 0;
	fast_rec_tmp_parser_struct.boolean = 0;
}

static void parser_tmp_struct_destroy()
{
	parser_tmp_struct_reset();
	cl_list_destroy(&fast_rec_tmp_parser_struct.str_list);
	cl_list_remove_all(&port_group_list);
	cl_list_destroy(&port_group_list);
}

static boolean_t is_credit_watchdog()
{
	return ber_type == IB_BER_TYPE_MAX;
}

static void start_threshold(ib_fast_recovery_threshold_type_t thr_type)
{
	threshold_type = thr_type;
	RESET_BUFFER;
}

static void configure_profile_conf_params(osm_port_group_t * p_pgrp, uint8_t profile)
{
	cl_map_item_t *p_item;
	osm_port_group_member_t *p_grp_m;
	osm_port_t *p_port;
	osm_physp_t *p_physp;
	osm_switch_t *p_sw;
	int i;

	OSM_ASSERT(profile <= IB_PROFILE_CONFIG_MAX_PROFILE);

	/* Set to all physical switch ports of the group */
	for (p_item = cl_qmap_head(&p_pgrp->ports);
	     p_item != cl_qmap_end(&p_pgrp->ports);
	     p_item = cl_qmap_next(p_item)) {
		p_grp_m = (osm_port_group_member_t *)p_item;
		p_port = p_grp_m->port;
		p_sw = p_port->p_node->sw;
		if (!p_sw)
			continue;

		for (i = 1; i < p_port->p_node->physp_tbl_size; i++) {
			if (!p_grp_m->physp_members[i])
				continue;

			p_physp = osm_node_get_physp_ptr(p_port->p_node, i);
			if (p_physp)
				p_physp->fast_recovery_profile = profile;
		}

		/* Keep CreditWatchdogConfig values per node and profile */
		memcpy(&p_sw->fast_recovery_data.calc_credit_watchdog[profile],
		       &credit_watchdog_parsed,
		       sizeof(ib_credit_watchdog_config_t));

		for (i = 0; i < IB_BER_TYPE_MAX; i++) {
			memcpy(&p_sw->fast_recovery_data.calc_ber_config[i][profile],
			       (void *)&ber_config_parsed[i], sizeof(ib_ber_config_t));
			p_sw->fast_recovery_data.calc_default_thr[i][profile] = default_thr[i];
		}

		if (p_sw->fast_recovery_data.max_profile < profile)
			p_sw->fast_recovery_data.max_profile = profile;

	}
}

static void parser_conf_group_end()
{
	cl_list_iterator_t list_item;
	osm_port_group_t *p_cur_pgrp;

	for (list_item = cl_list_head(&port_group_list);
	     list_item != cl_list_end(&port_group_list);
	     list_item = cl_list_next(list_item)) {
		p_cur_pgrp = (osm_port_group_t *)cl_list_obj(list_item);
		if (p_cur_pgrp)
			configure_profile_conf_params(p_cur_pgrp, next_profile_num);
	}

	memset((void *)&credit_watchdog_parsed, 0, sizeof(ib_credit_watchdog_config_t));
	memset(ber_config_parsed, 0, sizeof(ber_config_parsed));

	cl_list_remove_all(&port_group_list);
	next_profile_num++;
}

static void clear_val(char **c)
{
	free(*c);
	*c = NULL;
}

static void yyerror(const char *format, ...)
{
	char s[256];
	va_list pvar;

	OSM_LOG_ENTER(&p_osm->log);

	va_start(pvar, format);
	vsnprintf(s, sizeof(s), format, pvar);
	va_end(pvar);

	OSM_LOG(&p_osm->log, OSM_LOG_ERROR, "ERR A107: "
		"Syntax error (line %d:%d): %s\n",
		fast_recovery_line_num, fast_recovery_column_num, s);
	OSM_LOG_EXIT(&p_osm->log);
}

int __fast_recovery_parser_wrap()
{
        return 1;
}

int __fast_recovery_parser_parse();
int __fast_recovery_parser_lex();

static void init_ber_node_fields(osm_switch_t * p_sw)
{
	memset(p_sw->fast_recovery_data.calc_default_thr, 0, sizeof(p_sw->fast_recovery_data.calc_default_thr));
	memset(p_sw->fast_recovery_data.calc_ber_config, 0, sizeof(p_sw->fast_recovery_data.calc_ber_config));
}

static void init_nodes_fast_recovery()
{
	osm_switch_t *p_sw;
	cl_map_item_t *p_next;
	int i;
	osm_physp_t *p_physp;

	/* Iterate over switches set all p_node->calc_credit_watchdog to 0 */
	p_next = cl_qmap_head(&p_osm->subn.sw_guid_tbl);
	while (p_next != cl_qmap_end(&p_osm->subn.sw_guid_tbl)) {
		p_sw = (osm_switch_t *)p_next;
		p_next = cl_qmap_next(p_next);

		for (i = 1; i < p_sw->p_node->physp_tbl_size; i++) {
			p_physp = osm_node_get_physp_ptr(p_sw->p_node, i);
			if (p_physp)
				p_physp->fast_recovery_profile = 0;
		}

		memset(&p_sw->fast_recovery_data.calc_credit_watchdog, 0,
		       (IB_PROFILE_CONFIG_MAX_PROFILE + 1) * sizeof(ib_credit_watchdog_config_t));

		init_ber_node_fields(p_sw);

		p_sw->fast_recovery_data.max_profile = 0;
	}
}

int osm_parse_fast_recovery_configuration_file(struct osm_opensm * osm_ptr)
{
	int res = 0;
	p_osm = osm_ptr;
	__fast_recovery_parser_in = NULL;
	parser_tmp_struct_init();
	fast_recovery_line_num = 0;
	fast_recovery_column_num = 0;
	next_profile_num = 1;

	init_nodes_fast_recovery();

	if (!p_osm->subn.opt.fast_recovery_conf_file) {
		OSM_LOG(&p_osm->log, OSM_LOG_ERROR,
			"ERR A101: No fast recovery configuration file provided - "
			"Quit fast recovery parser\n");
		res = 1;
		goto Exit;
	}

	__fast_recovery_parser_in = fopen(p_osm->subn.opt.fast_recovery_conf_file, "r");
	if (!__fast_recovery_parser_in) {
		OSM_LOG(&p_osm->log, OSM_LOG_ERROR,
			"ERR A102: Fast recovery configuration file specified but not found\n");
		res = 1;
		goto Exit;
	}

        res = __fast_recovery_parser_parse();
	if (res)
		OSM_LOG(&p_osm->log, OSM_LOG_ERROR,
			"ERR A103: Fast recovery configuration file parsing failed\n");
	else
		OSM_LOG(&p_osm->log, OSM_LOG_DEBUG, "Fast recovery configuration "
			"file parsed successfully\n");

Exit:
	if (__fast_recovery_parser_in) {
		fclose(__fast_recovery_parser_in);
		__fast_recovery_parser_in = NULL;
	}
	clear_val(&__fast_recovery_parser_yylval);
	parser_tmp_struct_destroy();
	return res;
}

#line 365 "./osm_fast_recovery_parser_y.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "osm_fast_recovery_parser_y.h".  */
#ifndef YY__FAST_RECOVERY_PARSER_OSM_FAST_RECOVERY_PARSER_Y_H_INCLUDED
# define YY__FAST_RECOVERY_PARSER_OSM_FAST_RECOVERY_PARSER_Y_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int __fast_recovery_parser_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    COMMENT = 258,
    COMMA = 259,
    NUMBER = 260,
    NUMBER_EXP = 261,
    TEXT = 262,
    TK_TRUE = 263,
    TK_FALSE = 264,
    PORT_CONF_START = 265,
    PORT_CONF_END = 266,
    PORT_GROUP_NAME = 267,
    CREDIT_WATCHDOG_START = 268,
    CREDIT_WATCHDOG_END = 269,
    RAW_BER_START = 270,
    RAW_BER_END = 271,
    EFFECTIVE_BER_START = 272,
    EFFECTIVE_BER_END = 273,
    SYMBOL_BER_START = 274,
    SYMBOL_BER_END = 275,
    GROUP_ERR_THR_ACT = 276,
    ERR_ACT_NO_RESET = 277,
    ERR_ACT_PHYSICAL_RESET = 278,
    ERR_ACT_LOGICAL_RESET = 279,
    GROUP_ENABLE_THR = 280,
    ENABLE_NONE = 281,
    ENABLE_ERROR = 282,
    ENABLE_WARN_NORMAL = 283,
    ENABLE_ALL = 284,
    GROUP_ERR_THR = 285,
    GROUP_WARN_THR = 286,
    GROUP_NORM_THR = 287,
    GROUP_TIME_WINDOW = 288,
    GROUP_SAMPLING_RATE = 289,
    GROUP_DEFAULT_THR = 290
  };
#endif
/* Tokens.  */
#define COMMENT 258
#define COMMA 259
#define NUMBER 260
#define NUMBER_EXP 261
#define TEXT 262
#define TK_TRUE 263
#define TK_FALSE 264
#define PORT_CONF_START 265
#define PORT_CONF_END 266
#define PORT_GROUP_NAME 267
#define CREDIT_WATCHDOG_START 268
#define CREDIT_WATCHDOG_END 269
#define RAW_BER_START 270
#define RAW_BER_END 271
#define EFFECTIVE_BER_START 272
#define EFFECTIVE_BER_END 273
#define SYMBOL_BER_START 274
#define SYMBOL_BER_END 275
#define GROUP_ERR_THR_ACT 276
#define ERR_ACT_NO_RESET 277
#define ERR_ACT_PHYSICAL_RESET 278
#define ERR_ACT_LOGICAL_RESET 279
#define GROUP_ENABLE_THR 280
#define ENABLE_NONE 281
#define ENABLE_ERROR 282
#define ENABLE_WARN_NORMAL 283
#define ENABLE_ALL 284
#define GROUP_ERR_THR 285
#define GROUP_WARN_THR 286
#define GROUP_NORM_THR 287
#define GROUP_TIME_WINDOW 288
#define GROUP_SAMPLING_RATE 289
#define GROUP_DEFAULT_THR 290

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE __fast_recovery_parser_lval;

int __fast_recovery_parser_parse (void);

#endif /* !YY__FAST_RECOVERY_PARSER_OSM_FAST_RECOVERY_PARSER_Y_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 486 "./osm_fast_recovery_parser_y.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   91

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  36
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  64
/* YYNRULES -- Number of rules.  */
#define YYNRULES  91
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  110

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   290

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   335,   335,   337,   338,   341,   343,   344,   389,   390,
     393,   394,   406,   410,   411,   414,   415,   416,   417,   418,
     419,   422,   423,   424,   426,   427,   430,   434,   435,   438,
     442,   443,   446,   450,   451,   454,   455,   456,   457,   460,
     461,   464,   467,   468,   469,   470,   471,   474,   498,   502,
     503,   506,   517,   521,   523,   523,   523,   525,   529,   533,
     544,   548,   549,   550,   553,   556,   559,   563,   575,   579,
     580,   581,   582,   585,   588,   591,   594,   598,   600,   602,
     604,   606,   608,   610,   611,   614,   640,   724,   736,   740,
     745,   749
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "COMMENT", "COMMA", "NUMBER",
  "NUMBER_EXP", "TEXT", "TK_TRUE", "TK_FALSE", "PORT_CONF_START",
  "PORT_CONF_END", "PORT_GROUP_NAME", "CREDIT_WATCHDOG_START",
  "CREDIT_WATCHDOG_END", "RAW_BER_START", "RAW_BER_END",
  "EFFECTIVE_BER_START", "EFFECTIVE_BER_END", "SYMBOL_BER_START",
  "SYMBOL_BER_END", "GROUP_ERR_THR_ACT", "ERR_ACT_NO_RESET",
  "ERR_ACT_PHYSICAL_RESET", "ERR_ACT_LOGICAL_RESET", "GROUP_ENABLE_THR",
  "ENABLE_NONE", "ENABLE_ERROR", "ENABLE_WARN_NORMAL", "ENABLE_ALL",
  "GROUP_ERR_THR", "GROUP_WARN_THR", "GROUP_NORM_THR", "GROUP_TIME_WINDOW",
  "GROUP_SAMPLING_RATE", "GROUP_DEFAULT_THR", "$accept",
  "fast_recovery_policy", "configurations", "comment", "configuration",
  "conf_groups", "conf_group", "conf_group_start", "conf_group_end",
  "conf_group_entries", "conf_group_entry", "credit_watchdog",
  "credit_watchdog_start", "credit_watchdog_end", "raw_ber",
  "raw_ber_start", "raw_ber_end", "effective_ber", "effective_ber_start",
  "effective_ber_end", "symbol_ber", "symbol_ber_start", "symbol_ber_end",
  "mad_fields_entries", "mad_fields_entry", "credit_watchdog_fields",
  "ber_fields", "mad_fields", "port_group_name", "port_group_name_start",
  "string_list", "single_string", "default_thr", "default_thr_start",
  "bool", "true", "false", "err_thr_act", "err_thr_act_start",
  "err_thr_act_options", "err_thr_act_no_reset",
  "err_thr_act_physical_reset", "err_thr_act_logical_reset", "en_thr",
  "en_thr_start", "en_thr_options", "en_thr_none", "en_thr_error",
  "en_thr_warn_normal", "en_thr_all", "error_thr", "error_thr_start",
  "warning_thr", "warning_thr_start", "normal_thr", "normal_thr_start",
  "threshold", "threshold_number", "threshold_exp", "time_window",
  "time_window_start", "sampling_rate", "sampling_rate_start", "number", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290
};
# endif

#define YYPACT_NINF -57

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-57)))

#define YYTABLE_NINF -1

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int8 yypact[] =
{
     -57,    10,    -2,   -57,   -57,   -57,   -57,   -57,    13,   -57,
     -57,   -57,     2,   -57,   -57,   -57,   -57,   -57,   -57,   -57,
     -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,
     -57,    18,    -3,    17,    36,    52,   -57,    39,   -57,   -57,
     -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,
     -57,   -57,   -57,   -57,   -57,    32,   -57,   -20,   -57,    62,
     -57,    29,   -57,    29,   -57,    29,   -57,    40,   -57,    40,
     -57,   -57,   -57,   -57,   -57,   -57,    18,   -57,   -57,   -57,
     -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,
     -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,
     -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       3,     0,     2,     1,     5,    11,     7,     4,     6,     8,
      13,     9,     0,    12,    48,    22,    25,    28,    31,    20,
      10,    14,    16,    33,    17,    33,    18,    33,    19,    33,
      15,     0,     0,     0,     0,     0,    51,    47,    49,    23,
      60,    68,    78,    80,    82,    88,    90,    53,    38,    21,
      34,    35,    36,    37,    41,     0,    42,     0,    43,     0,
      44,     0,    45,     0,    46,     0,    39,     0,    40,     0,
      26,    24,    29,    27,    32,    30,     0,    91,    57,    58,
      52,    55,    56,    54,    64,    65,    66,    59,    61,    62,
      63,    73,    74,    75,    76,    67,    69,    70,    71,    72,
      86,    77,    83,    84,    85,    79,    81,    87,    89,    50
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -57,   -57,   -57,     4,   -57,   -57,    28,   -57,   -57,   -57,
     -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,
     -57,   -57,   -57,    31,   -57,   -57,   -57,   -57,   -57,   -57,
     -57,   -32,   -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,
     -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,   -57,
     -57,   -57,   -57,   -57,   -57,   -57,   -56,   -57,   -57,   -57,
     -57,   -57,   -57,   -43
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     1,     2,    48,     7,     8,     9,    10,    20,    12,
      21,    22,    23,    49,    24,    25,    71,    26,    27,    73,
      28,    29,    75,    32,    50,    51,    52,    53,    30,    31,
      37,    38,    54,    55,    80,    81,    82,    56,    57,    87,
      88,    89,    90,    58,    59,    95,    96,    97,    98,    99,
      60,    61,    62,    63,    64,    65,   101,   102,   103,    66,
      67,    68,    69,   104
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
       4,     4,    84,    85,    86,     4,     6,   105,     5,   106,
       3,    39,    83,    13,    14,    15,    19,    16,    40,    17,
       4,    18,    41,     5,   107,    36,   108,    42,    43,    44,
      45,    46,    47,    70,    77,   100,    11,    77,    40,     4,
      78,    79,    41,    76,   109,    77,     0,    42,    43,    44,
      45,    46,    47,     0,    72,     4,    33,    40,    34,     0,
      35,    41,     0,     0,     0,     0,    42,    43,    44,    45,
      46,    47,    74,    40,     0,     0,     0,    41,     0,     0,
       0,     0,    42,    43,    44,    45,    46,    47,    91,    92,
      93,    94
};

static const yytype_int8 yycheck[] =
{
       3,     3,    22,    23,    24,     3,     2,    63,    10,    65,
       0,    14,    55,    11,    12,    13,    12,    15,    21,    17,
       3,    19,    25,    10,    67,     7,    69,    30,    31,    32,
      33,    34,    35,    16,     5,     6,     8,     5,    21,     3,
       8,     9,    25,     4,    76,     5,    -1,    30,    31,    32,
      33,    34,    35,    -1,    18,     3,    25,    21,    27,    -1,
      29,    25,    -1,    -1,    -1,    -1,    30,    31,    32,    33,
      34,    35,    20,    21,    -1,    -1,    -1,    25,    -1,    -1,
      -1,    -1,    30,    31,    32,    33,    34,    35,    26,    27,
      28,    29
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    37,    38,     0,     3,    10,    39,    40,    41,    42,
      43,    42,    45,    11,    12,    13,    15,    17,    19,    39,
      44,    46,    47,    48,    50,    51,    53,    54,    56,    57,
      64,    65,    59,    59,    59,    59,     7,    66,    67,    14,
      21,    25,    30,    31,    32,    33,    34,    35,    39,    49,
      60,    61,    62,    63,    68,    69,    73,    74,    79,    80,
      86,    87,    88,    89,    90,    91,    95,    96,    97,    98,
      16,    52,    18,    55,    20,    58,     4,     5,     8,     9,
      70,    71,    72,    99,    22,    23,    24,    75,    76,    77,
      78,    26,    27,    28,    29,    81,    82,    83,    84,    85,
       6,    92,    93,    94,    99,    92,    92,    99,    99,    67
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    36,    37,    38,    38,    39,    40,    40,    41,    41,
      42,    43,    44,    45,    45,    46,    46,    46,    46,    46,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    59,    60,    60,    60,    60,    61,
      61,    62,    63,    63,    63,    63,    63,    64,    65,    66,
      66,    67,    68,    69,    70,    70,    70,    71,    72,    73,
      74,    75,    75,    75,    76,    77,    78,    79,    80,    81,
      81,    81,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    92,    93,    94,    95,    96,    97,
      98,    99
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     0,     2,     1,     1,     1,     1,     2,
       3,     1,     1,     0,     2,     1,     1,     1,     1,     1,
       1,     3,     1,     1,     3,     1,     1,     3,     1,     1,
       3,     1,     1,     0,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     1,     1,
       3,     1,     2,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     1,     2,
       1,     2,     1,     1,     1,     1,     1,     2,     1,     2,
       1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 5:
#line 341 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {}
#line 1670 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 11:
#line 394 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {
		/*
		 * HACK: limit to maximum of 8 profiles.
		 * Later should limit to 8 per switch.
		 */
		if (next_profile_num > IB_PROFILE_CONFIG_MAX_PROFILE) {
			OSM_LOG(&p_osm->log, OSM_LOG_ERROR, "ERR A108: "
				"Fast Recovery parser supports up to %d sections. "
				"Aborting parsing\n", IB_PROFILE_CONFIG_MAX_PROFILE);
			return 1;
		}
	}
#line 1687 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 12:
#line 406 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {
		parser_conf_group_end();
	}
#line 1695 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 22:
#line 423 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {}
#line 1701 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 23:
#line 424 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {}
#line 1707 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 25:
#line 427 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {
				ber_type = IB_BER_TYPE_RAW;
			}
#line 1715 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 26:
#line 430 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {
				ber_type = IB_BER_TYPE_MAX;
			}
#line 1723 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 28:
#line 435 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {
				ber_type = IB_BER_TYPE_EFFECTIVE;
			}
#line 1731 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 29:
#line 438 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {
				ber_type = IB_BER_TYPE_MAX;
			}
#line 1739 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 31:
#line 443 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {
				ber_type = IB_BER_TYPE_SYMBOL;
			}
#line 1747 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 32:
#line 446 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {
				ber_type = IB_BER_TYPE_MAX;
			}
#line 1755 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 47:
#line 474 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {
		cl_list_iterator_t list_item;
		char *tmp_str;
		osm_port_group_t *p_port_grp;

		for (list_item = cl_list_head(&fast_rec_tmp_parser_struct.str_list);
		     list_item != cl_list_end(&fast_rec_tmp_parser_struct.str_list);
		     list_item = cl_list_next(list_item)) {
			tmp_str = (char *)cl_list_obj(list_item);
			if (tmp_str) {
				p_port_grp = osm_get_port_grp(p_osm, tmp_str);
				if (p_port_grp) {
					cl_list_insert_tail(&port_group_list, p_port_grp);
				} else {
					OSM_LOG(&p_osm->log, OSM_LOG_ERROR, "ERR A104: "
						"Port group with name (%s) does not exist\n",
						tmp_str);
				}
			}
			free(tmp_str);
		}
		cl_list_remove_all(&fast_rec_tmp_parser_struct.str_list);
	}
#line 1783 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 48:
#line 498 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {
		RESET_BUFFER;
	}
#line 1791 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 51:
#line 506 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {
		char *tmp_str = strdup(__fast_recovery_parser_yylval);
		if (!tmp_str) {
			OSM_LOG(&p_osm->log, OSM_LOG_ERROR,
				"ERR A105: Couldn't allocate memory for "
				"port group name, Aborting parsing\n");
			return 1;
		}
		cl_list_insert_tail(&fast_rec_tmp_parser_struct.str_list, tmp_str);
	}
#line 1806 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 52:
#line 517 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {
		default_thr[ber_type] = fast_rec_tmp_parser_struct.boolean;
	}
#line 1814 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 53:
#line 521 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    { RESET_BUFFER; }
#line 1820 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 56:
#line 523 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {}
#line 1826 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 57:
#line 525 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {
		fast_rec_tmp_parser_struct.boolean = 1;
	}
#line 1834 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 58:
#line 529 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {
		fast_rec_tmp_parser_struct.boolean = 0;
	}
#line 1842 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 59:
#line 533 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {
		if (is_credit_watchdog())
			ib_credit_watchdog_config_set_err_threshold_action(
			    &credit_watchdog_parsed,
			    fast_rec_tmp_parser_struct.num);
		else /* BER */
			ib_ber_config_set_err_threshold_action(
			    &ber_config_parsed[ber_type],
			    fast_rec_tmp_parser_struct.num);
	}
#line 1857 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 60:
#line 544 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {
		RESET_BUFFER;
	}
#line 1865 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 64:
#line 553 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {
		fast_rec_tmp_parser_struct.num = 0;
       }
#line 1873 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 65:
#line 556 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {
		fast_rec_tmp_parser_struct.num = 1;
       }
#line 1881 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 66:
#line 559 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {
		fast_rec_tmp_parser_struct.num = 2;
       }
#line 1889 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 67:
#line 563 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {
		if (is_credit_watchdog())
			ib_credit_watchdog_config_set_en_threshold(
			    &credit_watchdog_parsed,
			    fast_rec_tmp_parser_struct.num);
		else /* BER */
			ib_ber_config_set_en_threshold(
			    &ber_config_parsed[ber_type],
			    fast_rec_tmp_parser_struct.num);
	}
#line 1904 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 68:
#line 575 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {
		RESET_BUFFER;
	}
#line 1912 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 73:
#line 585 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {
		fast_rec_tmp_parser_struct.num = 0;
	  }
#line 1920 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 74:
#line 588 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {
		fast_rec_tmp_parser_struct.num = 1;
	  }
#line 1928 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 75:
#line 591 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {
		fast_rec_tmp_parser_struct.num = 2;
	  }
#line 1936 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 76:
#line 594 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {
		fast_rec_tmp_parser_struct.num = 3;
	  }
#line 1944 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 78:
#line 600 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    { start_threshold(IB_THR_TYPE_ERROR); }
#line 1950 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 80:
#line 604 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    { start_threshold(IB_THR_TYPE_WARNING); }
#line 1956 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 82:
#line 608 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    { start_threshold(IB_THR_TYPE_NORMAL); }
#line 1962 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 85:
#line 614 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {
		if (is_credit_watchdog()) {
			uint8_t threshold = fast_rec_tmp_parser_struct.num;
			if (fast_rec_tmp_parser_struct.num > IB_CREDIT_WATCHDOG_MAX_THRESHOLD) {
				OSM_LOG(&p_osm->log, OSM_LOG_INFO,
					"CreditwatchdogConfig threshold %u is exceeding "
					"maximal value %u. "
					"Setting threshold to maximal value.\n",
					fast_rec_tmp_parser_struct.num,
					IB_CREDIT_WATCHDOG_MAX_THRESHOLD);
				threshold = IB_CREDIT_WATCHDOG_MAX_THRESHOLD;
			}

			ib_credit_watchdog_config_set_threshold(
			    &credit_watchdog_parsed, threshold_type,
			    threshold);
		} else {
			uint16_t threshold =
			    (fast_rec_tmp_parser_struct.num << IB_BER_THR_MANTISSA_SHIFT);
			ib_ber_config_set_threshold(&ber_config_parsed[ber_type],
						    threshold_type, threshold);
		}

		threshold_type = IB_THR_TYPE_RESERVED;
	}
#line 1992 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 86:
#line 640 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {
		char *threshold_str;
		double threshold_double;
		uint32_t exponent = 0;
		uint32_t mantissa = 0;
		uint16_t threshold = 0;
		int n;

		if (is_credit_watchdog()) {
			OSM_LOG(&p_osm->log, OSM_LOG_ERROR, "ERR A106: "
				"CreditWatchdogConfig threshold must be an integer\n");
			return 1;
		}

		threshold_str = strdup(__fast_recovery_parser_yylval);
		if (!threshold_str) {
			OSM_LOG(&p_osm->log, OSM_LOG_ERROR,
				"ERR A109: Couldn't allocate memory for "
				"exponent, Aborting parsing\n");
			return 1;
		}

		/*
		 * parse threshold specified as [1-9]e-[0-9][0-9]
		 *
		 * This section improves threshold parsing accuracy
		 * it allows setting the exact exponent and mantissa specified by
		 * the user when the string is in the format of [1-9]e-[0-9][0-9].
		 *
		 * Currently the parser reads the specified threshold into a double, and
		 * then converts it to mantissa ^ -10 exponent.
		 * Due to issues with FP representations and the conversion functions, some
		 * values might be inaccurately converted.
		 * For example, "1e-13" is converted to 9e-14 and "5e-15" is converted to 4e-15.
		 */
		n = sscanf(threshold_str, "%1ue-%2u", &mantissa, &exponent);
		if (n == 2) {
			if (mantissa == 0 || exponent > IB_BER_THR_EXPONENT_MAX) {
				OSM_LOG(&p_osm->log, OSM_LOG_ERROR,
					"ERR A10D: Couldn't parse threshold value out of range, "
					" Aborting parsing\n");
				free(threshold_str);
				return 1;
			}
			goto set_threshold;
		}

		/* parse threshold generic floating point format */
		n = sscanf(threshold_str, "%lg", &threshold_double);
		if (n != 1) {
			OSM_LOG(&p_osm->log, OSM_LOG_ERROR,
				"ERR A10B: Couldn't parse threshold value\n");
			free(threshold_str);
			return 1;
		}

		if (threshold_double <= 0 || threshold_double >= 1) {
			OSM_LOG(&p_osm->log, OSM_LOG_ERROR,
				"ERR A10C: threshold value out of range (0 .. 1)\n");
			free(threshold_str);
			return 1;
		}

		while (threshold_double < 1 && exponent < IB_BER_THR_EXPONENT_MAX) {
			threshold_double = threshold_double * 10;
			exponent++;
		}

		mantissa = (uint8_t)(floor(threshold_double));

		/* mantissa should be between 1 and 9 */
		if (!mantissa)
			mantissa = 1;

	set_threshold:
		/* set value */
		threshold = exponent | (mantissa << IB_BER_THR_MANTISSA_SHIFT);
		ib_ber_config_set_threshold(&ber_config_parsed[ber_type],
					    threshold_type, threshold);

		threshold_type = IB_THR_TYPE_RESERVED;
		free(threshold_str);
       }
#line 2080 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 87:
#line 724 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {
		if (!is_credit_watchdog()) {
			OSM_LOG(&p_osm->log, OSM_LOG_ERROR, "ERR A10A: "
				"Time window for BER is not configured by SM."
				"Aborting parsing.\n");
			return 1;
		}

		ib_credit_watchdog_config_set_time_window(
		    &credit_watchdog_parsed, fast_rec_tmp_parser_struct.num);
	}
#line 2096 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 88:
#line 736 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {
		RESET_BUFFER;
	}
#line 2104 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 89:
#line 740 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {
		ib_credit_watchdog_config_set_sampling_rate(
		    &credit_watchdog_parsed, fast_rec_tmp_parser_struct.num);
	}
#line 2113 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 90:
#line 745 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {
		RESET_BUFFER;
	}
#line 2121 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;

  case 91:
#line 749 "./osm_fast_recovery_parser_y.y" /* yacc.c:1646  */
    {
		fast_rec_tmp_parser_struct.num = strtoull(__fast_recovery_parser_yylval, NULL, 0);
		fast_rec_tmp_parser_struct.boolean = (fast_rec_tmp_parser_struct.num > 0);
	}
#line 2130 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
    break;


#line 2134 "./osm_fast_recovery_parser_y.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 753 "./osm_fast_recovery_parser_y.y" /* yacc.c:1906  */

